package com.vendor.loader.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.math.BigInteger;

public class StringUtil {
  public static boolean hexInRange(String value, String min, String max) {
    BigInteger v = toBigInteger(value);
    BigInteger a = toBigInteger(min);
    BigInteger b = toBigInteger(max);
    if (v.compareTo(a) < 0 || v.compareTo(b) > 0)
      return false; 
    return true;
  }
  
  public static BigInteger toBigInteger(String text) {
    boolean hex = (text.startsWith("0x") || text.startsWith("0X"));
    BigInteger textInteger = new BigInteger(hex ? text.substring(2) : text, hex ? 16 : 10);
    return textInteger;
  }
  
  public static String removeQuotes(String fileName) {
    if (fileName.startsWith("\"") && fileName.endsWith("\""))
      return fileName.substring(1, fileName.length() - 1); 
    if (fileName.startsWith("'") && fileName.endsWith("'"))
      return fileName.substring(1, fileName.length() - 1); 
    return fileName;
  }
  
  public static String toHexString(long value, int len) {
    StringBuilder sb = new StringBuilder();
    sb.append("0x");
    String str = Integer.toHexString((int)value);
    for (int i = str.length(); i < len; i++)
      sb.append("0"); 
    sb.append(str);
    return sb.toString();
  }
  
  public static String toHexStr(long value, int len) {
    StringBuilder sb = new StringBuilder();
    String str = Integer.toHexString((int)value);
    for (int i = str.length(); i < len; i++)
      sb.append("0"); 
    if (str.length() == 8) {
      sb.append(str.subSequence(6, 8));
    } else {
      sb.append(str);
    } 
    return sb.toString();
  }
  
  public static String convertString(String value, int len) {
    StringBuilder sb = new StringBuilder();
    if (value.startsWith("0x") || value.startsWith("0X")) {
      sb.append("0x");
      String str = value.substring(2);
      for (int i = str.length(); i < len; i++)
        sb.append("0"); 
      sb.append(str);
    } else {
      sb.append(value);
    } 
    return sb.toString();
  }
  
  public static long convertString(String str) {
    if (str.trim().isEmpty())
      return 0L; 
    if (str.startsWith("0x") || str.startsWith("0X"))
      return Long.parseLong(str.substring(2), 16); 
    return Long.parseLong(str, 10);
  }
  
  public static String addQuote(String str) {
    return "\"" + str + "\"";
  }
  
  public static String convertUnit(long num) {
    String unit = "";
    if (num == 0L)
      return "0"; 
    if (num % 1024L != 0L)
      return "" + num; 
    unit = "K";
    num /= 1024L;
    if (num < 1024L)
      return "" + num + num; 
    if (num % 1024L != 0L)
      return "" + num + num; 
    unit = "M";
    num /= 1024L;
    return "" + num + num;
  }
  
  public static long convertToNumber(String strNum) {
    if (strNum == null || strNum.trim().length() == 0)
      return -1L; 
    strNum = strNum.toLowerCase();
    long unit = 1L;
    int index = strNum.length();
    if ((index = strNum.indexOf("g")) != -1) {
      unit = 1073741824L;
    } else if ((index = strNum.indexOf("k")) != -1) {
      unit = 1024L;
    } else if ((index = strNum.indexOf("m")) != -1) {
      unit = 1048576L;
    } else if ((index = strNum.indexOf("b")) != -1) {
      unit = 1L;
    } else {
      index = strNum.length();
    } 
    try {
      return Long.parseLong(strNum.substring(0, index)) * unit;
    } catch (NumberFormatException e) {
      return -1L;
    } 
  }
  
  public static void printByte(byte[] tsStreamByte) {
    System.out.print("[");
    for (byte b : tsStreamByte)
      System.out.print("0x" + Integer.toHexString(b & 0xFF) + " "); 
    System.out.println("]");
  }
}
